export const __webpack_id__ = "lib_handle-config_index_mjs";
export const __webpack_ids__ = ["lib_handle-config_index_mjs"];
export const __webpack_modules__ = {

/***/ "./lib/handle-config/config.mjs":
/*!**************************************!*\
  !*** ./lib/handle-config/config.mjs ***!
  \**************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   orders: () => (/* binding */ orders),
/* harmony export */   root: () => (/* binding */ root)
/* harmony export */ });
const root = [
  'openapi',
  'info',
  'jsonSchemaDialect',
  'servers',
  'paths',
  'webhooks',
  'components',
  'security',
  'tags',
  'externalDocs',
];

const examples = ['summary', 'description', 'value', 'externalValue'];
const content = ['schema', 'encoding', 'example', 'examples'];
const schema = [
  '$schema',
  '$id',
  '$comment',
  '$defs',
  '$ref',

  'title',
  'description',
  'deprecated',

  'units',
  'isEven',

  'allOf',
  'anyOf',
  'oneOf',
  'not',

  'dependentRequired',
  'dependentSchemas',
  'if',
  'then',
  'else',

  'type',
  'const',
  'enum',

  'contentEncoding',
  'contentMediaType',

  'format',
  'pattern',
  'minLength',
  'maxLength',

  'minimum',
  'maximum',
  'exclusiveMinimum',
  'exclusiveMaximum',
  'multipleOf',

  'propertyNames',
  'properties',
  'patternProperties',
  'additionalProperties',
  'unevaluatedProperties',
  'requiredProperties',
  'minProperties',
  'maxProperties',
  'required',

  'items',
  'uniqueItems',
  'prefixItems',
  'contains',
  'minContains',
  'maxContains',
  'minItems',
  'maxItems',

  'default',
  'examples',

  'example',
  'externalDocs',
  'discriminator',
  'xml',
];

const orders = {
  info: [
    'version',
    'title',
    'summary',
    'description',
    'contact',
    'license',
    'termsOfService',
  ],
  'info/license': ['name', 'identifier', 'url'],
  'info/contact': ['name', 'email', 'url'],

  '**/servers/*': ['url', 'description', 'variables'],
  '**/servers/*/variables': ['enum', 'default', 'description'],

  'tags/*': ['name', 'description', 'externalDocs'],

  '**/externalDocs': ['url', 'description'],

  components: [
    'schemas',
    'parameters',
    'headers',
    'requestBodies',
    'responses',
    'examples',
    'links',
    'callbacks',
    'pathItems',
    'securitySchemes',
  ],

  'components/{schemas,requestBodies,headers,examples,links,callbacks,securitySchemes}':
    [],

  'components/schemas/*': schema,
  'components/{parameters,headers,responses/*/headers}/*/schema': schema,
  'components/{responses,parameters,headers,responses/*/headers,requestBodies}/*/content/application※json/schema':
    schema,
  '{components/pathItems,paths,webhooks}/*/parameters/*/schema': schema,
  '{components/pathItems,paths,webhooks}/*/parameters/*/content/application※json/schema':
    schema,
  '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{parameters,responses/*/headers}/*/schema':
    schema,
  '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{requestBody,parameters/*,headers/*,responses/*/headers/*}/content/application※json/schema':
    schema,

  'components/**/{schemas,schema}/**/{items,prefixItems,additionalProperties,properties/*,patternProperties/*,allOf/*,anyOf/*,oneOf/*}':
    schema,

  'components/{parameters,headers}/*': [
    'name',
    'description',
    'in',
    'required',
    'deprecated',
    'allowEmptyValue',
    'style',
    'explode',
    'allowReserved',
    'schema',
    'example',
    'examples',
    'content',
  ],
  get '{components/pathItems,paths,webhooks}/*/parameters/*'() {
    return this['components/{parameters,headers}/*'];
  },
  get '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{parameters,responses/*/headers}/*'() {
    return this['components/{parameters,headers}/*'];
  },

  get 'components/responses/*/headers/*'() {
    return this['components/{parameters,headers}/*'];
  },

  'components/responses': ['default'],

  get '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/responses'() {
    return this['components/responses'];
  },

  'components/{responses,responses/*/headers,requestBodies,parameters,headers}/*/content/*':
    content,
  '{components/pathItems,paths,webhooks}/*/parameters/*/content/*': content,
  '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{parameters/*/content,requestBody/content,responses/*/content,responses/*/headers/*/content}/*':
    content,

  'components/{responses,requestBodies}/*/content/*/encoding/*': [
    'contentType',
    'headers',
    'style',
    'explode',
    'allowReserved',
  ],
  get '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{requestBody,responses/*}/content/*/encoding/*'() {
    return this['components/{responses,requestBodies}/*/content/*/encoding/*'];
  },

  'components/examples/*': examples,
  'components/{parameters,parameters/*/content,headers,headers/*/content,requestBodies/*/content,responses/*/content,responses/*/headers,responses/*/headers/*/content}/*/examples/*':
    examples,
  '{components/pathItems,paths,webhooks}/*/{parameters,parameters/*/content}/*/examples/*':
    examples,
  '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/{requestBody/content,responses/*/content,responses/*/headers,responses/*/headers/*/content,parameters,parameters/*/content}/*/examples/*':
    examples,

  '{components/pathItems,paths,webhooks}/*': [
    '$ref',
    'summary',
    'description',
    'servers',
    'parameters',
    'get',
    'post',
    'put',
    'patch',
    'delete',
    'head',
    'options',
    'trace',
  ],
  '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}':
    [
      'operationId',
      'deprecated',
      'summary',
      'description',
      'tags',
      'externalDocs',
      'parameters',
      'requestBody',
      'responses',
      'callbacks',
      'security',
      'servers',
    ],

  'components/requestBodies/*': ['required', 'description', 'content'],
  get '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/requestBody'() {
    return this['components/requestBodies/*'];
  },

  'components/responses/*': ['description', 'headers', 'content', 'links'],
  get '{components/pathItems,paths,webhooks}/*/{get,post,put,patch,delete,head,options,trace}/responses/*'() {
    return this['components/responses/*'];
  },

  'components/securitySchemes/*': [
    'type',
    'name',
    'description',
    'in',
    'scheme',
    'bearerFormat',
    'flows',
    'openIdConnectUrl',
  ],
  'components/securitySchemes/*/flows': [
    'implicit',
    'password',
    'clientCredentials',
    'authorizationCode',
  ],
  'components/securitySchemes/*/flows/*': [
    'authorizationUrl',
    'tokenUrl',
    'refreshUrl',
    'scopes',
  ],
};


/***/ }),

/***/ "./lib/handle-config/index.mjs":
/*!*************************************!*\
  !*** ./lib/handle-config/index.mjs ***!
  \*************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   handleConfig: () => (/* binding */ handleConfig)
/* harmony export */ });
/* harmony import */ var _transform_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./transform.mjs */ "./lib/handle-config/transform.mjs");
/* harmony import */ var _utils_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./utils.mjs */ "./lib/handle-config/utils.mjs");



async function handleConfig(files) {
  for (const file of files) {
    const data = (0,_utils_mjs__WEBPACK_IMPORTED_MODULE_1__.read)(file);

    const result = (0,_transform_mjs__WEBPACK_IMPORTED_MODULE_0__.transform)(data);

    if (result) {
      (0,_utils_mjs__WEBPACK_IMPORTED_MODULE_1__.write)(file, result);
    }
  }
}


/***/ }),

/***/ "./lib/handle-config/transform.mjs":
/*!*****************************************!*\
  !*** ./lib/handle-config/transform.mjs ***!
  \*****************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   transform: () => (/* binding */ transform)
/* harmony export */ });
/* harmony import */ var micromatch__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! micromatch */ "./node_modules/.pnpm/micromatch@4.0.8/node_modules/micromatch/index.js");
/* harmony import */ var object_traversal__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! object-traversal */ "./node_modules/.pnpm/object-traversal@1.0.1/node_modules/object-traversal/dist/object-traversal.esm.js");
/* harmony import */ var sort_keys__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! sort-keys */ "./node_modules/.pnpm/sort-keys@5.1.0/node_modules/sort-keys/index.js");
/* harmony import */ var _config_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./config.mjs */ "./lib/handle-config/config.mjs");
/* harmony import */ var _utils_mjs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./utils.mjs */ "./lib/handle-config/utils.mjs");
/* eslint-disable no-param-reassign */







const patterns = Object.keys(_config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders).filter(
  (glob) => glob.includes('*') || glob.includes('{'),
);

function findPattern(nodePath) {
  return nodePath
    ? nodePath in _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders
      ? nodePath
      : patterns.find((glob) => micromatch__WEBPACK_IMPORTED_MODULE_0__.isMatch(nodePath, glob))
    : undefined;
}

function transform(data) {
  const { openapi } = data;

  if (typeof openapi !== 'string' || !/^3\.\d+\.\d+$/.test(openapi)) {
    return null;
  }

  const io = (0,_utils_mjs__WEBPACK_IMPORTED_MODULE_3__.sortKeys)((0,sort_keys__WEBPACK_IMPORTED_MODULE_4__["default"])(data, { deep: true }), { keys: _config_mjs__WEBPACK_IMPORTED_MODULE_2__.root });

  const temp = {};

  (0,object_traversal__WEBPACK_IMPORTED_MODULE_1__.traverse)(
    io,
    ({ parent, key, value, meta: { nodePath } }) => {
      const mark = nodePath
        ? nodePath.replaceAll('/', '※').replaceAll('☀', '/')
        : undefined;

      const path = findPattern(mark);

      if (path && _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders[path]) {
        if (Array.isArray(value)) {
          if (
            value.length > 0 &&
            typeof _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders[path] === 'string' &&
            _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders[path]
          ) {
            temp[mark] = () => {
              parent[key] = (0,_utils_mjs__WEBPACK_IMPORTED_MODULE_3__.sortBy)(value, _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders[path]);
            };
          }
        } else if (typeof value === 'object' && Object.keys(value).length > 0) {
          temp[mark] = () => {
            parent[key] = (0,_utils_mjs__WEBPACK_IMPORTED_MODULE_3__.sortKeys)(value, { keys: _config_mjs__WEBPACK_IMPORTED_MODULE_2__.orders[path] });
          };
        }
      }
    },
    {
      pathSeparator: '☀',
    },
  );

  Object.keys(temp)
    .sort()
    .reverse()
    .forEach((mark) => {
      temp[mark]();
    });

  return io;
}


/***/ }),

/***/ "./lib/handle-config/utils.mjs":
/*!*************************************!*\
  !*** ./lib/handle-config/utils.mjs ***!
  \*************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   read: () => (/* binding */ read),
/* harmony export */   sortBy: () => (/* binding */ sortBy),
/* harmony export */   sortKeys: () => (/* binding */ sortKeys),
/* harmony export */   write: () => (/* binding */ write)
/* harmony export */ });
/* harmony import */ var node_fs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! node:fs */ "node:fs");
/* harmony import */ var yaml__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! yaml */ "./node_modules/.pnpm/yaml@2.7.0/node_modules/yaml/dist/index.js");




function read(path) {
  const raw = (0,node_fs__WEBPACK_IMPORTED_MODULE_0__.readFileSync)(path, 'utf8');

  return /\.json$/.test(path) ? JSON.parse(raw) : yaml__WEBPACK_IMPORTED_MODULE_1__.parse(raw);
}

function write(path, data) {
  const raw = /\.json$/.test(path)
    ? JSON.stringify(data, null, 2)
    : yaml__WEBPACK_IMPORTED_MODULE_1__.stringify(data);

  (0,node_fs__WEBPACK_IMPORTED_MODULE_0__.writeFileSync)(path, raw);
}

function sortBy(array, key) {
  return array.sort(({ [key]: a }, { [key]: b }) => {
    return a.localeCompare(b);
  });
}

function sortKeys(object, { keys }) {
  const io = Object.entries(object);

  io.sort(
    keys.length === 0
      ? ([a], [b]) => a.localeCompare(b)
      : ([a], [b]) => {
          if (!keys.includes(a)) {
            return 1;
          }

          if (!keys.includes(b)) {
            return -1;
          }

          return keys.indexOf(a) - keys.indexOf(b);
        },
  );

  return Object.fromEntries(io);
}


/***/ })

};
