export const __webpack_id__ = "lib_handle-script_index_mjs";
export const __webpack_ids__ = ["lib_handle-script_index_mjs"];
export const __webpack_modules__ = {

/***/ "./lib/handle-script/index.mjs":
/*!*************************************!*\
  !*** ./lib/handle-script/index.mjs ***!
  \*************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   handleScript: () => (/* binding */ handleScript)
/* harmony export */ });
/* harmony import */ var eslint__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! eslint */ "eslint");
/* harmony import */ var _utils_fs_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../utils/fs.mjs */ "./lib/utils/fs.mjs");
/* harmony import */ var _options_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./options.mjs */ "./lib/handle-script/options.mjs");






function handleScript(files) {
  const eslint = new eslint__WEBPACK_IMPORTED_MODULE_0__.ESLint(_options_mjs__WEBPACK_IMPORTED_MODULE_2__.options);

  return eslint.lintFiles(files).then((results) => {
    const error = results.find(({ messages }) =>
      messages.find(({ fatal }) => fatal),
    );

    if (error) {
      throw new _utils_fs_mjs__WEBPACK_IMPORTED_MODULE_1__.GarouError(
        error.messages.find(({ fatal }) => fatal).message,
        error.filePath,
      );
    }

    return eslint__WEBPACK_IMPORTED_MODULE_0__.ESLint.outputFixes(results);
  });
}


/***/ }),

/***/ "./lib/handle-script/options.mjs":
/*!***************************************!*\
  !*** ./lib/handle-script/options.mjs ***!
  \***************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   options: () => (/* binding */ options)
/* harmony export */ });
/* harmony import */ var _nice_move_eslint_plugin_html_lib_configs_next_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @nice-move/eslint-plugin-html/lib/configs-next.mjs */ "./node_modules/.pnpm/@nice-move+eslint-plugin-html@0.1.1_eslint@9.17.0/node_modules/@nice-move/eslint-plugin-html/lib/configs-next.mjs");
/* harmony import */ var _stylistic_eslint_plugin_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @stylistic/eslint-plugin-js */ "@stylistic/eslint-plugin-js");
/* harmony import */ var _stylistic_eslint_plugin_jsx__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @stylistic/eslint-plugin-jsx */ "@stylistic/eslint-plugin-jsx");
/* harmony import */ var _stylistic_eslint_plugin_ts__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @stylistic/eslint-plugin-ts */ "@stylistic/eslint-plugin-ts");
/* harmony import */ var _typescript_eslint_parser__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @typescript-eslint/parser */ "@typescript-eslint/parser");
/* harmony import */ var eslint_plugin_sort_class_members__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! eslint-plugin-sort-class-members */ "./node_modules/.pnpm/eslint-plugin-sort-class-members@1.21.0_eslint@9.17.0/node_modules/eslint-plugin-sort-class-members/dist/index.js");
/* harmony import */ var vue_eslint_parser__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! vue-eslint-parser */ "vue-eslint-parser");
/* harmony import */ var _plugins_mjs__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./plugins.mjs */ "./lib/handle-script/plugins.mjs");
/* harmony import */ var _react_mjs__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./react.mjs */ "./lib/handle-script/react.mjs");
/* harmony import */ var _vue_mjs__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./vue.mjs */ "./lib/handle-script/vue.mjs");













const always = [
  'iife',
  'class',
  'function',
  'export',
  'cjs-import',
  'cjs-export',
  'block-like',
  'return',
];

const never = ['break', 'case', 'default', 'continue', 'debugger', 'switch'];

const padding = [
  'warn',
  {
    blankLine: 'always',
    prev: '*',
    next: always,
  },
  {
    blankLine: 'always',
    prev: ['directive', 'import', ...always],
    next: '*',
  },
  {
    blankLine: 'never',
    prev: '*',
    next: never,
  },
  {
    blankLine: 'never',
    prev: never,
    next: '*',
  },
  {
    blankLine: 'any',
    prev: 'import',
    next: 'import',
  },
  {
    blankLine: 'never',
    prev: 'cjs-import',
    next: 'cjs-import',
  },
];

const comment = [
  'warn',
  'always',
  {
    block: {
      balanced: true,
      exceptions: ['-', '+', '/', '*'],
      markers: ['=', '!', ':', '::', '/', '*'],
    },
    line: {
      exceptions: ['-', '+', '/', '*'],
      markers: ['=', '!', '/', '*'],
    },
  },
];

const quotes = [
  'warn',
  'single',
  {
    avoidEscape: true,
    allowTemplateLiterals: false,
  },
];

const props = [
  'warn',
  {
    callbacksLast: false,
    shorthandFirst: false,
    shorthandLast: false,
    ignoreCase: false,
    noSortAlphabetically: false,
    reservedFirst: true,
  },
];

const baseConfig = {
  files: ['**/*.{js,jsx,ts,tsx,mjs,mts,cjs,cts,qs,wxs,vue}'],
  languageOptions: {
    ecmaVersion: 'latest',
    sourceType: 'module',
    parserOptions: {
      ecmaFeatures: {
        impliedStrict: true,
        globalReturn: true,
      },
    },
  },
  rules: {
    curly: ['warn', 'all'],
    'no-useless-rename': 'warn',
    'prefer-exponentiation-operator': 'warn',
    'prefer-template': 'warn',
    'object-shorthand': [
      'warn',
      'always',
      {
        avoidQuotes: true,
      },
    ],
    'sort-class-members/sort-class-members': [
      'warn',
      {
        accessorPairPositioning: 'getThenSet',
        order: [
          '[static-properties]',
          '[static-methods]',
          '[properties]',
          '[conventional-private-properties]',
          'constructor',
          'componentWillMount',
          'componentDidMount',
          'componentWillReceiveProps',
          'shouldComponentUpdate',
          'componentWillUpdate',
          'componentDidUpdate',
          'componentWillUnmount',
          '[arrow-function-properties]',
          '[methods]',
          '[conventional-private-methods]',
          'render',
        ],
      },
    ],
    ..._plugins_mjs__WEBPACK_IMPORTED_MODULE_7__.rules,
  },
  plugins: _plugins_mjs__WEBPACK_IMPORTED_MODULE_7__.pluginMap,
};

const options = {
  allowInlineConfig: false,
  errorOnUnmatchedPattern: false,
  fix: true,
  globInputPaths: false,
  overrideConfigFile: true,
  baseConfig: [
    eslint_plugin_sort_class_members__WEBPACK_IMPORTED_MODULE_5__.configs['flat/recommended'],
    ..._nice_move_eslint_plugin_html_lib_configs_next_mjs__WEBPACK_IMPORTED_MODULE_0__.base,
    baseConfig,
    {
      files: ['**/*.md'],
      processor: 'garou/markdown',
      plugins: _plugins_mjs__WEBPACK_IMPORTED_MODULE_7__.pluginMap,
    },
    {
      files: ['**/*.md/**'],
      languageOptions: {
        ecmaVersion: 'latest',
      },
    },
    {
      files: ['**/*.ts', '**/*.tsx', '**/*.cts', '**/*.mts'],
      languageOptions: {
        parser: _typescript_eslint_parser__WEBPACK_IMPORTED_MODULE_4__["default"],
      },
      rules: {
        'garou/consistent-type-specifier-style': ['warn', 'prefer-top-level'],
      },
    },
    {
      files: ['**/*.jsx', '**/*.tsx'],
      languageOptions: {
        parserOptions: {
          ecmaFeatures: {
            jsx: true,
          },
        },
      },
      rules: _react_mjs__WEBPACK_IMPORTED_MODULE_8__.rules,
    },
    {
      files: ['**/*.vue'],
      languageOptions: {
        ecmaVersion: 'latest',
        parser: vue_eslint_parser__WEBPACK_IMPORTED_MODULE_6__["default"],
      },
      rules: _vue_mjs__WEBPACK_IMPORTED_MODULE_9__.rules,
    },
    {
      files: [
        '**/*.cjs',
        '**/*.js',
        '**/*.jsx',
        '**/*.mjs',
        '**/*.qs',
        '**/*.vue',
        '**/*.wxs',
      ],
      plugins: {
        '@stylistic/js': _stylistic_eslint_plugin_js__WEBPACK_IMPORTED_MODULE_1__["default"],
      },
      rules: {
        '@stylistic/js/lines-between-class-members': 'warn',
        '@stylistic/js/padding-line-between-statements': padding,
        '@stylistic/js/quotes': quotes,
        '@stylistic/js/spaced-comment': comment,
      },
    },
    {
      files: ['**/*.ts', '**/*.mts', '**/*.cts', '**/*.tsx'],
      plugins: {
        '@stylistic/ts': _stylistic_eslint_plugin_ts__WEBPACK_IMPORTED_MODULE_3__["default"],
        '@stylistic/js': _stylistic_eslint_plugin_js__WEBPACK_IMPORTED_MODULE_1__["default"],
      },
      rules: {
        '@stylistic/js/quotes': quotes,
        '@stylistic/js/spaced-comment': comment,
        '@stylistic/ts/lines-between-class-members': 'warn',
        '@stylistic/ts/padding-line-between-statements': padding,
      },
    },
    {
      files: ['**/*.jsx', '**/*.tsx'],
      plugins: {
        '@stylistic/jsx': _stylistic_eslint_plugin_jsx__WEBPACK_IMPORTED_MODULE_2__["default"],
      },
      rules: {
        '@stylistic/jsx/jsx-sort-props': props,
        '@stylistic/jsx/jsx-self-closing-comp': 'warn',
        '@stylistic/jsx/jsx-curly-brace-presence': [
          'warn',
          { props: 'never', children: 'ignore' },
        ],
      },
    },
  ],
};


/***/ }),

/***/ "./lib/handle-script/plugins.mjs":
/*!***************************************!*\
  !*** ./lib/handle-script/plugins.mjs ***!
  \***************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   pluginMap: () => (/* binding */ pluginMap),
/* harmony export */   rules: () => (/* binding */ rules)
/* harmony export */ });
/* harmony import */ var eslint_plugin_import_lib_rules_consistent_type_specifier_style_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! eslint-plugin-import/lib/rules/consistent-type-specifier-style.js */ "./node_modules/.pnpm/eslint-plugin-import@2.31.0_@typescript-eslint+parser@8.19.1_eslint@9.17.0_typescript@5.7.2__eslint@9.17.0/node_modules/eslint-plugin-import/lib/rules/consistent-type-specifier-style.js");
/* harmony import */ var eslint_plugin_import_lib_rules_no_duplicates_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! eslint-plugin-import/lib/rules/no-duplicates.js */ "./node_modules/.pnpm/eslint-plugin-import@2.31.0_@typescript-eslint+parser@8.19.1_eslint@9.17.0_typescript@5.7.2__eslint@9.17.0/node_modules/eslint-plugin-import/lib/rules/no-duplicates.js");
/* harmony import */ var eslint_plugin_markdown_lib_processor_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! eslint-plugin-markdown/lib/processor.js */ "./node_modules/.pnpm/eslint-plugin-markdown@5.1.0_eslint@9.17.0/node_modules/eslint-plugin-markdown/lib/processor.js");
/* harmony import */ var eslint_plugin_simple_import_sort__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! eslint-plugin-simple-import-sort */ "./node_modules/.pnpm/eslint-plugin-simple-import-sort@12.1.1_eslint@9.17.0/node_modules/eslint-plugin-simple-import-sort/index.js");
/* harmony import */ var _react_mjs__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./react.mjs */ "./lib/handle-script/react.mjs");
/* harmony import */ var _vue_mjs__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./vue.mjs */ "./lib/handle-script/vue.mjs");








const pluginMap = {
  garou: {
    processors: {
      markdown: eslint_plugin_markdown_lib_processor_js__WEBPACK_IMPORTED_MODULE_2__,
    },
    rules: {
      'import-no-duplicates': eslint_plugin_import_lib_rules_no_duplicates_js__WEBPACK_IMPORTED_MODULE_1__,
      'consistent-type-specifier-style': eslint_plugin_import_lib_rules_consistent_type_specifier_style_js__WEBPACK_IMPORTED_MODULE_0__,
      'sort-exports': eslint_plugin_simple_import_sort__WEBPACK_IMPORTED_MODULE_3__.rules.exports,
      // 'sort-imports': simpleImportSort.rules.imports,
    },
  },
  'garou-react': _react_mjs__WEBPACK_IMPORTED_MODULE_4__.plugin,
  'garou-vue': _vue_mjs__WEBPACK_IMPORTED_MODULE_5__.plugin,
};

const rules = {
  'garou/sort-exports': 'warn',
  'garou/import-no-duplicates': ['error', { considerQueryString: true }],
};


/***/ }),

/***/ "./lib/handle-script/react.mjs":
/*!*************************************!*\
  !*** ./lib/handle-script/react.mjs ***!
  \*************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   plugin: () => (/* binding */ plugin),
/* harmony export */   rules: () => (/* binding */ rules)
/* harmony export */ });
/* harmony import */ var eslint_plugin_react_lib_rules_jsx_boolean_value_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! eslint-plugin-react/lib/rules/jsx-boolean-value.js */ "./node_modules/.pnpm/eslint-plugin-react@7.37.3_eslint@9.17.0/node_modules/eslint-plugin-react/lib/rules/jsx-boolean-value.js");


const plugin = {
  rules: {
    'jsx-boolean-value': eslint_plugin_react_lib_rules_jsx_boolean_value_js__WEBPACK_IMPORTED_MODULE_0__,
  },
};

const rules = {
  'garou-react/jsx-boolean-value': ['warn', 'always'],
};


/***/ }),

/***/ "./lib/handle-script/vue.mjs":
/*!***********************************!*\
  !*** ./lib/handle-script/vue.mjs ***!
  \***********************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   plugin: () => (/* binding */ plugin),
/* harmony export */   rules: () => (/* binding */ rules)
/* harmony export */ });
/* harmony import */ var eslint_plugin_vue_lib_rules_attributes_order_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/attributes-order.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/attributes-order.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_component_tags_order_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/component-tags-order.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/component-tags-order.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_html_comment_content_newline_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/html-comment-content-newline.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/html-comment-content-newline.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_html_comment_content_spacing_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/html-comment-content-spacing.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/html-comment-content-spacing.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_html_comment_indent_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/html-comment-indent.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/html-comment-indent.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_html_self_closing_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/html-self-closing.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/html-self-closing.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_object_shorthand_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/object-shorthand.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/object-shorthand.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_order_in_components_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/order-in-components.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/order-in-components.js");
/* harmony import */ var eslint_plugin_vue_lib_rules_padding_line_between_blocks_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! eslint-plugin-vue/lib/rules/padding-line-between-blocks.js */ "./node_modules/.pnpm/eslint-plugin-vue@9.32.0_eslint@9.17.0/node_modules/eslint-plugin-vue/lib/rules/padding-line-between-blocks.js");










const plugin = {
  rules: {
    'attributes-order': eslint_plugin_vue_lib_rules_attributes_order_js__WEBPACK_IMPORTED_MODULE_0__,
    'component-tags-order': eslint_plugin_vue_lib_rules_component_tags_order_js__WEBPACK_IMPORTED_MODULE_1__,
    'html-comment-content-newline': eslint_plugin_vue_lib_rules_html_comment_content_newline_js__WEBPACK_IMPORTED_MODULE_2__,
    'html-comment-content-spacing': eslint_plugin_vue_lib_rules_html_comment_content_spacing_js__WEBPACK_IMPORTED_MODULE_3__,
    'html-comment-indent': eslint_plugin_vue_lib_rules_html_comment_indent_js__WEBPACK_IMPORTED_MODULE_4__,
    'html-self-closing': eslint_plugin_vue_lib_rules_html_self_closing_js__WEBPACK_IMPORTED_MODULE_5__,
    'object-shorthand': eslint_plugin_vue_lib_rules_object_shorthand_js__WEBPACK_IMPORTED_MODULE_6__,
    'order-in-components': eslint_plugin_vue_lib_rules_order_in_components_js__WEBPACK_IMPORTED_MODULE_7__,
    'padding-line-between-blocks': eslint_plugin_vue_lib_rules_padding_line_between_blocks_js__WEBPACK_IMPORTED_MODULE_8__,
  },
};

const rules = {
  'garou-vue/component-tags-order': [
    'warn',
    { order: ['template', 'script', 'style'] },
  ],
  'garou-vue/attributes-order': [
    'warn',
    {
      alphabetical: true,
    },
  ],
  'garou-vue/html-comment-content-newline': 'warn',
  'garou-vue/html-comment-content-spacing': 'warn',
  'garou-vue/html-comment-indent': 'warn',
  'garou-vue/html-self-closing': [
    'warn',
    {
      html: {
        void: 'always',
      },
    },
  ],
  'garou-vue/object-shorthand': [
    'warn',
    'always',
    {
      avoidQuotes: true,
    },
  ],
  'garou-vue/order-in-components': 'warn',
  'garou-vue/padding-line-between-blocks': 'warn',
};


/***/ }),

/***/ "./lib/utils/fs.mjs":
/*!**************************!*\
  !*** ./lib/utils/fs.mjs ***!
  \**************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GarouError: () => (/* binding */ GarouError),
/* harmony export */   readThenWrite: () => (/* binding */ readThenWrite)
/* harmony export */ });
/* harmony import */ var node_fs_promises__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! node:fs/promises */ "node:fs/promises");


class GarouError extends Error {
  constructor(message, filePath) {
    super(message);
    this.name = 'GarouError';

    if (filePath) {
      this.filePath = filePath;
    }
  }
}

async function readThenWrite(file, transform) {
  try {
    const origin = await (0,node_fs_promises__WEBPACK_IMPORTED_MODULE_0__.readFile)(file, 'utf8');
    const result = await transform(origin);

    if (result && result !== origin) {
      await (0,node_fs_promises__WEBPACK_IMPORTED_MODULE_0__.writeFile)(file, result);
    }
  } catch (error) {
    throw new GarouError(error.message, error.path);
  }
}


/***/ })

};
