export const __webpack_id__ = "lib_handle-yarnlock_mjs";
export const __webpack_ids__ = ["lib_handle-yarnlock_mjs"];
export const __webpack_modules__ = {

/***/ "./lib/handle-yarnlock.mjs":
/*!*********************************!*\
  !*** ./lib/handle-yarnlock.mjs ***!
  \*********************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   handleYarnLock: () => (/* binding */ handleYarnLock)
/* harmony export */ });
/* harmony import */ var _yarnpkg_lockfile__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @yarnpkg/lockfile */ "@yarnpkg/lockfile");
/* harmony import */ var yarn_deduplicate_dist_index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! yarn-deduplicate/dist/index.js */ "./node_modules/.pnpm/yarn-deduplicate@6.0.2/node_modules/yarn-deduplicate/dist/index.js");
/* harmony import */ var _utils_fs_mjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./utils/fs.mjs */ "./lib/utils/fs.mjs");





const { parse, stringify } = _yarnpkg_lockfile__WEBPACK_IMPORTED_MODULE_0__;

const parseYarnLock = (file) => parse(file).object;

function removeCache(url) {
  let io;

  try {
    io = new URL(url);
  } catch {
    return url;
  }

  if (
    io.search &&
    (io.searchParams.has('other_urls') ||
      (io.searchParams.has('cache') && io.searchParams.has('sync_timestamp')))
  ) {
    io.searchParams.delete('other_urls');
    io.searchParams.delete('cache');
    io.searchParams.delete('sync_timestamp');

    return io.toString();
  }

  return url;
}

function transform(data) {
  if (!data.includes('# yarn lockfile v1')) {
    return data;
  }

  const io = (0,yarn_deduplicate_dist_index_js__WEBPACK_IMPORTED_MODULE_1__.fixDuplicates)(data);

  const json = parseYarnLock(io);

  Object.values(json).forEach((item) => {
    if (item.resolved) {
      // eslint-disable-next-line no-param-reassign
      item.resolved = removeCache(item.resolved);
    }
  });

  return stringify(json);
}

async function handleYarnLock(files) {
  for (const file of files) {
    await (0,_utils_fs_mjs__WEBPACK_IMPORTED_MODULE_2__.readThenWrite)(file, transform);
  }
}


/***/ }),

/***/ "./lib/utils/fs.mjs":
/*!**************************!*\
  !*** ./lib/utils/fs.mjs ***!
  \**************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GarouError: () => (/* binding */ GarouError),
/* harmony export */   readThenWrite: () => (/* binding */ readThenWrite)
/* harmony export */ });
/* harmony import */ var node_fs_promises__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! node:fs/promises */ "node:fs/promises");


class GarouError extends Error {
  constructor(message, filePath) {
    super(message);
    this.name = 'GarouError';

    if (filePath) {
      this.filePath = filePath;
    }
  }
}

async function readThenWrite(file, transform) {
  try {
    const origin = await (0,node_fs_promises__WEBPACK_IMPORTED_MODULE_0__.readFile)(file, 'utf8');
    const result = await transform(origin);

    if (result && result !== origin) {
      await (0,node_fs_promises__WEBPACK_IMPORTED_MODULE_0__.writeFile)(file, result);
    }
  } catch (error) {
    throw new GarouError(error.message, error.path);
  }
}


/***/ })

};
